function Create(self)
	self.Ctrl = self:GetController()
	self.len = 33
	self.Obj = {}
	self.Links = {}
	
	local Orig = self.Pos+self:RotateOffset(Vector(0,self.len*0.5))
	for i = 1, 5 do
		self.Obj[i] = CreateMOSRotating("Joint", "Hammer.rte")
		if self.Obj[i] then
			self.Obj[i].Pos = Orig + Vector(0, self.len*i)
			self.Obj[i].Vel = self.Vel
			MovableMan:AddParticle(self.Obj[i])
		end
	end
	
	local i = #self.Obj + 1
	self.Obj[i] = CreateActor("Ball", "Hammer.rte")
	if self.Obj[i] then
		self.Obj[i].Pos = Orig + Vector(0, self.len*i)
		self.Obj[i].Vel = self.Vel
		self.Obj[i]:SetWhichMOToNotHit(self, -1)
		self.Obj[i].Team = self.Team
		MovableMan:AddParticle(self.Obj[i])
		
		self:SetWhichMOToNotHit(self.Obj[i], -1)
	end
	
	for i = 1, #self.Obj do
		self.Links[i] = CreateMOSRotating("Short Link " .. SelectRand(1,4), "Hammer.rte")
		if self.Links[i] then
			self.Links[i].Pos = Orig + Vector(0, self.len*(i-1)+self.len*0.5)
			self.Links[i].Vel = self.Vel
			MovableMan:AddParticle(self.Links[i])
		end
	end
end

function Destroy(self)
	if self.Pos.Y < -50 then		
		for i = 1, #self.Obj-1 do
			if MovableMan:IsParticle(self.Obj[i]) and self.Obj[i].PresetName == "Joint" then
				self.Obj[i].ToDelete = true
			end
		end
		
		if MovableMan:IsParticle(self.Obj[#self.Obj]) and self.Obj[#self.Obj].PresetName == "Ball" then
			self.Obj[#self.Obj].ToDelete = true
		end
		
		for i = 1, #self.Links do
			if MovableMan:IsParticle(self.Links[i]) and self.Links[i].PresetName == "Short Link" then
				self.Links[i].ToDelete = true
			end
		end
	end
end

function Update(self)
	self.ViewPoint = self.Pos + self:RotateOffset(Vector(0,40))
	
	local valid = true
	for i = 1, #self.Obj-1 do
		if not MovableMan:IsParticle(self.Obj[i]) or self.Obj[i].PresetName ~= "Joint" then
			valid = false
			break
		end
	end
	
	if valid then
		for i = 1, #self.Links do
			if not MovableMan:IsParticle(self.Links[i]) then
				valid = false
				break
			end
		end
	end
	
	if valid and MovableMan:ValidMO(self.Obj[#self.Obj]) and self.Obj[#self.Obj].PresetName == "Ball" then
		if self.RotAngle > 1.5 then
			self.AngularVel = self.AngularVel - 1
		elseif self.RotAngle < -1.5 then
			self.AngularVel = self.AngularVel + 1
		else
			self.AngularVel = self.AngularVel * 0.97
		end
		
		if self.Ctrl:IsState(Controller.MOVE_LEFT) and self.Vel.X > -15 then
			self:AddAbsForce(Vector(-80000, 0), self.Pos)
		elseif self.Ctrl:IsState(Controller.MOVE_RIGHT) and self.Vel.X < 15 then
			self:AddAbsForce(Vector(80000, 0), self.Pos)
		elseif self.Ctrl:IsState(Controller.MOVE_UP) and self.Vel.Y > -15 then
			self:AddAbsForce(Vector(0, -50000), self.Pos)
		elseif self.Ctrl:IsState(Controller.MOVE_DOWN) and self.Vel.Y < 15 then
			self:AddAbsForce(Vector(0, 90000), self.Pos)
		end
		
		local str = 25
		local fra = 0.6
		
		local i = 1
		local Orig = self.Pos + self:RotateOffset(Vector(0,self.len*0.5))
		local Dist = SceneMan:ShortestDistance(Orig, self.Obj[i].Pos, false)
		local len = Dist.Magnitude
		local ang = Dist.AbsRadAngle - 1.571
		self.Obj[i].RotAngle = ang
		self.Obj[i].Age = 1
		self.Obj[i].Sharpness = 1
		self.Obj[i].ToSettle = false
		
		local Force = self.Obj[i]:RotateOffset(Vector(0,(len-self.len)*str))
		self.Obj[i]:AddImpulseForce(Force, Vector(0,0))
		self.Obj[i].Pos = self.Obj[i].Pos - Dist*(0.15*(len-self.len)/len)
		self:AddImpulseForce(Force:RadRotate(3.14)*fra, Vector(0,0))
		
		self.Links[i].RotAngle = ang
		self.Links[i].Age = 1
		self.Links[i].Sharpness = 1
		self.Links[i].Vel = Vector(0,0)
		self.Links[i].Pos = Orig + Vector(0,-len*0.5):RadRotate(ang)
		
		
		i = 2
		Dist = SceneMan:ShortestDistance(self.Obj[i-1].Pos, self.Obj[i].Pos, false)
		len = Dist.Magnitude
		ang = Dist.AbsRadAngle - 1.571
		self.Obj[i].RotAngle = ang
		self.Obj[i].Age = 1
		self.Obj[i].Sharpness = 1
		self.Obj[i].ToSettle = false
		
		Force = self.Obj[i]:RotateOffset(Vector(0,(len-self.len)*str))
		self.Obj[i]:AddImpulseForce(Force, Vector(0,0))
		self.Obj[i].Pos = self.Obj[i].Pos - Dist*(0.15*(len-self.len)/len)
		self.Obj[i-1]:AddImpulseForce(Force:RadRotate(3.14)*fra, Vector(0,0))
		
		self.Links[i].RotAngle = ang
		self.Links[i].Age = 1
		self.Links[i].Sharpness = 1
		self.Links[i].Vel = Vector(0,0)
		self.Links[i].Pos = self.Obj[i-1].Pos + Vector(0,-len*0.5):RadRotate(ang)
		
		
		i = 3
		Dist = SceneMan:ShortestDistance(self.Obj[i-1].Pos, self.Obj[i].Pos, false)
		len = Dist.Magnitude
		ang = Dist.AbsRadAngle - 1.571
		self.Obj[i].RotAngle = ang
		self.Obj[i].Age = 1
		self.Obj[i].Sharpness = 1
		self.Obj[i].ToSettle = false
		
		Force = self.Obj[i]:RotateOffset(Vector(0,(len-self.len)*str))
		self.Obj[i]:AddImpulseForce(Force, Vector(0,0))
		self.Obj[i].Pos = self.Obj[i].Pos - Dist*(0.15*(len-self.len)/len)
		self.Obj[i-1]:AddImpulseForce(Force:RadRotate(3.14)*fra, Vector(0,0))
		
		self.Links[i].RotAngle = ang
		self.Links[i].Age = 1
		self.Links[i].Sharpness = 1
		self.Links[i].Vel = Vector(0,0)
		self.Links[i].Pos = self.Obj[i-1].Pos + Vector(0,-len*0.5):RadRotate(ang)
		
		
		i = 4
		Dist = SceneMan:ShortestDistance(self.Obj[i-1].Pos, self.Obj[i].Pos, false)
		len = Dist.Magnitude
		ang = Dist.AbsRadAngle - 1.571
		self.Obj[i].RotAngle = ang
		self.Obj[i].Age = 1
		self.Obj[i].Sharpness = 1
		self.Obj[i].ToSettle = false
		
		Force = self.Obj[i]:RotateOffset(Vector(0,(len-self.len)*str))
		self.Obj[i]:AddImpulseForce(Force, Vector(0,0))
		self.Obj[i].Pos = self.Obj[i].Pos - Dist*(0.15*(len-self.len)/len)
		self.Obj[i-1]:AddImpulseForce(Force:RadRotate(3.14)*fra, Vector(0,0))
		
		self.Links[i].RotAngle = ang
		self.Links[i].Age = 1
		self.Links[i].Sharpness = 1
		self.Links[i].Vel = Vector(0,0)
		self.Links[i].Pos = self.Obj[i-1].Pos + Vector(0,-len*0.5):RadRotate(ang)
		
		
		i = 5
		Dist = SceneMan:ShortestDistance(self.Obj[i-1].Pos, self.Obj[i].Pos, false)
		len = Dist.Magnitude
		ang = Dist.AbsRadAngle - 1.571
		self.Obj[i].RotAngle = ang
		self.Obj[i].Age = 1
		self.Obj[i].Sharpness = 1
		self.Obj[i].ToSettle = false
		
		Force = self.Obj[i]:RotateOffset(Vector(0,(len-self.len)*str))
		self.Obj[i]:AddImpulseForce(Force, Vector(0,0))
		self.Obj[i].Pos = self.Obj[i].Pos - Dist*(0.15*(len-self.len)/len)
		self.Obj[i-1]:AddImpulseForce(Force:RadRotate(3.14)*fra, Vector(0,0))
		
		self.Links[i].RotAngle = ang
		self.Links[i].Age = 1
		self.Links[i].Sharpness = 1
		self.Links[i].Vel = Vector(0,0)
		self.Links[i].Pos = self.Obj[i-1].Pos + Vector(0,-len*0.5):RadRotate(ang)
		
		
		i = 6
		Dist = SceneMan:ShortestDistance(self.Obj[i-1].Pos, self.Obj[i].Pos, false)
		len = Dist.Magnitude
		ang = Dist.AbsRadAngle - 1.571
		self.Obj[i].RotAngle = ang
		self.Obj[i].Age = 1
		self.Obj[i].Sharpness = 1
		self.Obj[i].Health = 100
		self.Obj[i].ToSettle = false
		
		Force = self.Obj[i]:RotateOffset(Vector(0,(len-self.len)*250))
		self.Obj[i]:AddImpulseForce(Force, Vector(0,0))
		self.Obj[i].Pos = self.Obj[i].Pos - Dist*(0.05*(len-self.len)/len)
		self.Obj[i-1]:AddImpulseForce(Force:RadRotate(3.14)*0.05, Vector(0,0))
		
		self.Links[i].RotAngle = ang
		self.Links[i].Age = 1
		self.Links[i].Sharpness = 1
		self.Links[i].Vel = Vector(0,0)
		self.Links[i].Pos = self.Obj[i-1].Pos + Vector(0,-len*0.5):RadRotate(ang)
	end
end