function Create(self)
	self.Ctrl = self:GetController()
	self.len = 170
	
	self.Hammer = CreateActor("Blunt Hammer", "Hammer.rte")
	if self.Hammer then
		self.Hammer.Pos = self.Pos + self:RotateOffset(Vector(0, self.len))
		self.Hammer.Vel = self.Vel
		MovableMan:AddParticle(self.Hammer)
	end

	self.Link = CreateMOSRotating("Link", "Hammer.rte")
	if self.Link then
		self.Link.Pos = self.Pos + self:RotateOffset(Vector(0, 40))
		self.Link.Vel = self.Vel
		MovableMan:AddParticle(self.Link)
	end
end

function Destroy(self)
	if self.Pos.Y < -50 then
		if MovableMan:IsParticle(self.Hammer) and self.Hammer.PresetName == "Blunt Hammer" then
			self.Hammer.ToDelete = true
		end
		
		if MovableMan:IsParticle(self.Link) and self.Link.PresetName == "Link" then
			self.Link.ToDelete = true
		end
	end
end

function Update(self)
	self.ViewPoint = self.Pos + self:RotateOffset(Vector(0,40))
	
	if MovableMan:ValidMO(self.Hammer) and self.Hammer.PresetName == "Blunt Hammer" and
		MovableMan:IsParticle(self.Link) and self.Link.PresetName == "Link"
	then
		if self.RotAngle > 1.5 then
			self.AngularVel = self.AngularVel - 1
		elseif self.RotAngle < -1.5 then
			self.AngularVel = self.AngularVel + 1
		else
			self.AngularVel = self.AngularVel * 0.97
		end
		
		if self.Ctrl:IsState(Controller.MOVE_LEFT) and self.Vel.X > -15 then
			local Acc = Vector(-80000, 0)
			self:AddAbsForce(Acc, self.Pos)
		elseif self.Ctrl:IsState(Controller.MOVE_RIGHT) and self.Vel.X < 15 then
			local Acc = Vector(80000, 0)
			self:AddAbsForce(Acc, self.Pos)
		elseif self.Ctrl:IsState(Controller.MOVE_UP) and self.Vel.Y > -15 then
			local Acc = Vector(0, -50000)
			self:AddAbsForce(Acc, self.Pos)
		elseif self.Ctrl:IsState(Controller.MOVE_DOWN) and self.Vel.Y < 15 then
			local Acc = Vector(0, 90000)
			self:AddAbsForce(Acc, self.Pos)
		end
		
		-- Calculate the distance to the hammer
		local Dist = SceneMan:ShortestDistance(self.Pos, self.Hammer.Pos, false)
		local ang = Dist.AbsRadAngle - 1.571
		self.Hammer.RotAngle = ang
		self.Hammer.Age = 1
		self.Hammer.Sharpness = 1
		self.Hammer.ToSettle = false
		
		-- Add spring like force
		local len = Dist.Magnitude
		self.Hammer:AddImpulseForce(self.Hammer:RotateOffset(Vector(0,(len-self.len)*200)), Vector(0,0))
		
		-- Move the hammer a little to reduce oscillations
		self.Hammer.Pos = self.Hammer.Pos + self.Hammer:RotateOffset(Vector(0,(len-self.len)*0.1))
		
		-- Move the link
		self.Link.RotAngle = ang
		self.Link.Age = 1
		self.Link.Vel = Vector(0,0)
		self.Link.Pos = self.Pos + Vector(0,-self.len/1.8):RadRotate(ang)
	end
end